Index: /palm/trunk/SCRIPTS/NCL/spectra.ncl
===================================================================
--- /palm/trunk/SCRIPTS/NCL/spectra.ncl	(revision 565)
+++ /palm/trunk/SCRIPTS/NCL/spectra.ncl	(revision 566)
@@ -24,5 +24,6 @@
       print("Neither the personal configuration file '.ncl.config' exists in")
       print("~/palm/current_version")
-      print("nor the default configuration file '.ncl.config.default' exists in")
+      print("nor the default configuration file '.ncl.config.default' "+\
+            "exists in")
       print(palm_bin_path + "/NCL")
       print(" ")
@@ -59,5 +60,8 @@
    end if
 
-   if (format_out .NE. "x11" .AND. format_out .NE. "pdf" .AND. format_out .NE. "eps" .AND. format_out .NE. "ps" .AND. format_out .NE. "epsi" .AND. format_out .NE. "ncgm" .AND. format_out .NE. "png")then
+   if (format_out .NE. "x11" .AND. format_out .NE. "pdf" .AND.   \
+       format_out .NE. "eps" .AND. format_out .NE. "ps" .AND.    \
+       format_out .NE. "epsi" .AND. format_out .NE. "ncgm" .AND. \
+       format_out .NE. "png")then
       print(" ")
       print("'format_out = "+format_out+"' is invalid and set to'x11'")
@@ -136,5 +140,6 @@
    if (start_f .EQ. -1)then
       print(" ")
-      print("'start_f' must be one of the cyclic numbers (at least 0) of your input file(s)")
+      print("'start_f' must be one of the cyclic numbers (at least 0) of "+\
+            "your input file(s)")
       print(" ")  
       exit
@@ -142,5 +147,6 @@
    if (end_f .EQ. -1)then
       print(" ")
-      print("'end_f' must be one of the cyclic numbers (at least 0) of your input file(s)")
+      print("'end_f' must be one of the cyclic numbers (at least 0) of "+\
+            "your input file(s)")
       print(" ")  
       exit
@@ -224,5 +230,6 @@
 	    if (dim_level .GT. dimsizes(zu))then
                print(" ")
-               print("'height_level' has more elements than available height levels in input file (= "+dimz+")")
+               print("'height_level' has more elements than available "+\
+                     "height levels in input file (= "+dimsizes(zu)+")")
                print(" ")
                exit
@@ -230,4 +237,14 @@
 	       zuh=new(dim_level,double)
 	       do le=0,dim_level-1
+                  if (height_level(le) .GE. dimsizes(zu)) then
+                     no_levels=dimsizes(zu)-1
+                     print(" ")
+                     print("Element "+le+" of 'height_level' is greater "  +\
+                          "than the maximum available index in input file "+\
+                          "which is "+no_levels+". Note that the first "   +\
+                          "element has the index 0.")
+                     print(" ")
+                     exit
+                  end if
 	          zuh(le)=zu(height_level(le))
 	       end do
@@ -243,5 +260,6 @@
 	       if (dim_level .GT. dimsizes(zw))then
                   print(" ")
-                  print("'height_level' has more elements than available height levels in input file (= "+dimz+")")
+                  print("'height_level' has more elements than available "+\
+                        "height levels in input file (= "+dimsizes(zw)+")")
                   print(" ")
                   exit
@@ -249,4 +267,14 @@
 	          zwh=new(dim_level,double)
 	          do le=0,dim_level-1
+                     if (height_level(le) .GE. dimsizes(zw)) then
+                        no_levels=dimsizes(zw)-1
+                        print(" ")
+                        print("Element "+le+" of 'height_level' is greater "+\
+                              "than the maximum available index in input "  +\
+                              "file which is "+no_levels+". Note that the " +\
+                              "first element has the index 0.")
+                        print(" ")
+                        exit
+                     end if
 	             zwh(le)=zw(height_level(le))
 	          end do
@@ -267,5 +295,6 @@
       if (start_time_step .GT. t_all(nt-1)/3600)then
          print(" ")
-         print("'start_time_step' = "+ start_time_step +"h is greater than last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
+         print("'start_time_step' = "+ start_time_step +"h is greater than "+\
+               "last time step = "+ t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
          print(" ")
          print("Select another 'start_time_step'")
@@ -275,5 +304,6 @@
       if (start_time_step .LT. t_all(0)/3600)then
          print(" ")
-         print("'start_time_step' = "+ start_time_step +"h is lower than first time step = " + t_all(0)+"s = "+t_all(0)/3600+"h")        
+         print("'start_time_step' = "+ start_time_step +"h is lower than "+\
+               "first time step = "+ t_all(0)+"s = "+t_all(0)/3600+"h")        
          exit
       end if
@@ -281,5 +311,6 @@
 
    do i=0,nt-1     
-      if (start_time_step .GE. (t_all(i)-delta_t/2)/3600 .AND. start_time_step .LT. (t_all(i)+delta_t/2)/3600)then
+      if (start_time_step .GE. (t_all(i)-delta_t/2)/3600 .AND. \
+          start_time_step .LT. (t_all(i)+delta_t/2)/3600)then
          st=i
          break
@@ -305,5 +336,6 @@
       if (end_time_step .GT. t_all(nt-1)/3600)then
          print(" ")
-         print("'end_time_step' = "+ end_time_step +"h is greater than last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
+         print("'end_time_step' = "+ end_time_step +"h is greater than "+\
+               "last time step = " + t_all(nt-1)+"s = "+t_all(nt-1)/3600+"h")
          print(" ")
          print("Select another 'end_time_step'")  
@@ -313,5 +345,6 @@
       if (end_time_step .LT. start_time_step/3600)then
          print(" ")
-         print("'end_time_step' = "+ end_time_step +"h is lower than 'start_time_step' = "+start_time_step+"h")
+         print("'end_time_step' = "+ end_time_step +"h is lower than "+\
+               "'start_time_step' = "+start_time_step+"h")
          print(" ")
          print("Select another 'start_time_step' or 'end_time_step'")
@@ -322,5 +355,6 @@
 
    do i=0,nt-1     
-      if (end_time_step .GE. (t_all(i)-delta_t/2)/3600 .AND. end_time_step .LT. (t_all(i)+delta_t/2)/3600)then
+      if (end_time_step .GE. (t_all(i)-delta_t/2)/3600 .AND. \
+          end_time_step .LT. (t_all(i)+delta_t/2)/3600)then
          et=i
          break
@@ -343,6 +377,8 @@
 
    print(" ")
-   print("Output of time steps from "+t_all(start_time_step)/3600+" h = "+t_all(start_time_step)+" s => index = "+start_time_step)
-   print("                     till "+t_all(end_time_step)/3600+" h = "+t_all(end_time_step)+" s => index = "+end_time_step)
+   print("Output of time steps from "+t_all(start_time_step)/3600+" h = "+\
+         t_all(start_time_step)+" s => index = "+start_time_step)
+   print("                     till "+t_all(end_time_step)/3600+" h = "+\
+         t_all(end_time_step)+" s => index = "+end_time_step)
    print(" ")
 
@@ -387,14 +423,10 @@
    end if
 
-   legend_label=new(dimt,double)
+   legend_label=new(dimt,string)
    legend_label_zu=new(dimz,double)
    legend_label_zw=new(dimz,double)
    legend_label_z=new(dimz,double)
    do p=start_time_step,end_time_step
-      if (t_all(p)/3600 .LT. 1) then
-         legend_label(p-start_time_step)=decimalPlaces(t_all(p)/3600,2,True)
-      else
-         legend_label(p-start_time_step)=decimalPlaces(t_all(p)/3600,0,True)
-      end if
+      legend_label(p-start_time_step)=sprintf("%6.2f", t_all(p)/3600)
    end do  
    if (sort .EQ. "time")
@@ -447,5 +479,9 @@
       check = True
 
-      if ( isStrSubset( vNam(varn), "time") .OR. isStrSubset( vNam(varn), "zu_sp") .OR. isStrSubset( vNam(varn), "zw_sp") .OR. isStrSubset( vNam(varn), "k_x") .OR. isStrSubset( vNam(varn), "k_y")) then
+      if ( isStrSubset( vNam(varn), "time") .OR.  \
+           isStrSubset( vNam(varn), "zu_sp") .OR. \
+           isStrSubset( vNam(varn), "zw_sp") .OR. \
+           isStrSubset( vNam(varn), "k_x") .OR.   \
+           isStrSubset( vNam(varn), "k_y")) then
             check = False
       end if
@@ -458,5 +494,5 @@
 
          temp = f[:]->$vNam(varn)$
-	 data = temp(start_time_step:end_time_step,0:dimz-1,:)
+	 data = temp(start_time_step:end_time_step,0:dimz-1,:) 
 
          temp_att = f_att->$vNam(varn)$
@@ -467,10 +503,10 @@
          if (height_level(0) .NE. -1)then
 	    do te=0,dimz-1
-	    print(height_level(te))
-	       data(:,te,:) = temp(start_time_step:end_time_step,height_level(te),:)	       
+	       data(:,te,:) = temp(start_time_step:end_time_step,\
+                                                    height_level(te),:)	       
 	    end do
 	 end if
 
-         data=data/(norm_y*norm_x)  ;SMOOTHING: #temp=smth9(temp/norm, 0.50, -0.25, False)#
+         data=data/(norm_y*norm_x) 
             
          do i=0,b-1            
@@ -541,5 +577,6 @@
             res@pmLegendOrthogonalPosF  = -1.0
             res@pmLegendWidthF          = 0.12
-            res@pmLegendHeightF         = 0.04*(end_time_step-start_time_step+1)
+            res@pmLegendHeightF         = 0.04*\
+                                          (end_time_step-start_time_step+1)
             do p=dimz-1,0,1
 	       if (log_y .EQ. 1)then  
@@ -549,5 +586,7 @@
                            st=p+start_time_step
                            print(" ")
-                           print("'"+vNam(varn)+"("+st+","+q+","+r+")' is equal 0; Logarithmic scale for y-axis and height "+z(p)+" cannot be used")
+                           print("'"+vNam(varn)+"("+st+","+q+","+r+")' is "+\
+                                 "equal 0. Logarithmic scale for y-axis "+\
+                                 "and height "+z(p)+" cannot be used")
                            print(" ")
                            res@trYLog = False
@@ -577,5 +616,7 @@
                            st=p+start_time_step
                            print(" ")
-                           print("'"+vNam(varn)+"("+st+","+q+","+r+")' is equal 0; Logarithmic scale for y-axis and time "+legend_label(p)+" cannot be used")
+                           print("'"+vNam(varn)+"("+st+","+q+","+r+")' "+\
+                                 "is equal 0. Logarithmic scale for y-axis "+\
+                                 "and time "+legend_label(p)+" h cannot be used")
                            print(" ")
                            res@trYLog = False
@@ -583,11 +624,13 @@
                      end do
 		     if (norm_height .EQ. 1 .AND. p .EQ. 0)then
-		        data(p,q,:) = data(p,q,:)*doubletofloat(legend_label_z(q))
-			x_axis(q,:) = x_axis(q,:)*doubletofloat(legend_label_z(q))
+		        data(p,q,:) = data(p,q,:)*\
+                                           doubletofloat(legend_label_z(q))
+			x_axis(q,:) = x_axis(q,:)*\
+                                           doubletofloat(legend_label_z(q))
 		     end if
 	             max_y(q)=max(data(p,q,:))
 		     min_y(q)=min(data(p,q,:))
 		     min_x(q)=min(x_axis(q,:))
-		     max_x(q)=max(x_axis(q,:))                                    
+		     max_x(q)=max(x_axis(q,:))
                   end do 
 		  do q=0,dimz-1
@@ -597,5 +640,5 @@
 	             end if
 		     if (q .EQ. 0)then
-		        res@tiYAxisString      = "("+unit_y+")"		        
+		        res@tiYAxisString      = "("+unit_y+")"
 		        res@gsnLeftString      = vNam(varn)
                         res@gsnRightString     = "Time = "+legend_label(p)+"h"
@@ -605,5 +648,6 @@
                         res@trYMaxF = max(max_y)
 			
-			plot_h(q)  = gsn_csm_xy(wks,x_axis(q,:),data(p,q,:),res)
+			plot_h(q)  = gsn_csm_xy(wks,x_axis(q,:),\
+                                                         data(p,q,:),res)
 			
 			lgres = True
@@ -618,12 +662,12 @@
 			   lgres@lgLineColors = color
 			end if
-			lgres@lgTitleString = "Height (m)"  
+			lgres@lgTitleString      = "Height (m)"  
                         lgres@lgLabelFont        = "helvetica"
-			lgres@lgLabelFontHeightF     = font_size_legend*6 
-                        lgres@lgTitleFontHeightF     = font_size      
+			lgres@lgLabelFontHeightF = font_size_legend*6 
+                        lgres@lgTitleFontHeightF = font_size      
                         lgres@vpWidthF           = 0.12           
-                        lgres@vpHeightF          = font_size_legend*(dimz+3)           
+                        lgres@vpHeightF          = font_size_legend*(dimz+3)
   
-                        lbid = gsn_create_legend(wks,dimz,legend_label_z,lgres)       
+                        lbid = gsn_create_legend(wks,dimz,legend_label_z,lgres)
 
                         amres = True
@@ -632,5 +676,6 @@
                         annoid1 = gsn_add_annotation(plot_h(q),lbid,amres)
 		     else
-		        plot_h(q)  = gsn_csm_xy(wks,x_axis(q,:),data(p,q,:),res) 
+		        plot_h(q)  = gsn_csm_xy(wks,x_axis(q,:),\
+                                                        data(p,q,:),res) 
 			overlay(plot_h(0),plot_h(q))
 		     end if
@@ -672,5 +717,6 @@
    no_frames = 0
 
-   if ((format_out .EQ. "eps" .OR. format_out .EQ. "epsi") .AND. n .gt. no_rows*no_columns) then
+   if ((format_out .EQ. "eps" .OR. format_out .EQ. "epsi") .AND. \
+                                          n .gt. no_rows*no_columns) then
       gsn_panel(wks,plot,(/n,1/),resP)
       print(" ")
@@ -683,5 +729,6 @@
             no_frames = no_frames + 1
          else
-            gsn_panel(wks,plot(i:i+no_rows*no_columns-1),(/no_rows,no_columns/),resP)
+            gsn_panel(wks,plot(i:i+no_rows*no_columns-1),\
+                                           (/no_rows,no_columns/),resP)
             no_frames = no_frames + 1   
          end if
